;; -------------------------------- +
;;  Mouse-Hook DLL                  |
;; -------------------------------- +

include header.inc

;; -- Code section ----------------
_text segment 'CODE'

start				proc; \
;	hInst:				dword,
;	fdwReason:			dword,
;	lpvReserved:		dword
	;; --------------------------------

	cmp		dword ptr[esp+4+4],DLL_PROCESS_ATTACH
	jnz		@@return

	mov		eax,dword ptr[esp+4+0]
	mov		dword ptr[ModuleHandle],eax

	@@return:
	xor		eax,eax
	inc		eax
ret 12
start				endp

Hook0Proc			proc \
	nCode:			dword,
	wParam:			dword,
	lParam:			dword
	;; --------------------------------

	push	dword ptr[lParam]
	push	dword ptr[wParam]
	push	dword ptr[nCode]
	push	dword ptr[Hook0Handle]
	call	CallNextHookEx

	mov		eax,dword ptr[lParam]
	push	dword ptr[eax+MOUSEHOOKSTRUCT.pt.y]
	push	dword ptr[eax+MOUSEHOOKSTRUCT.pt.x]
	call	WindowFromPoint

	push	0
	push	eax
	push	WM_MOUSEHOOK
	push	dword ptr[hwnd]
	call	PostMessage

	xor		eax,eax
ret
Hook0Proc			endp

InstallHook			proc
	mov		dword ptr[hwnd],eax

	push	0
	push	dword ptr[ModuleHandle]
	push	offset Hook0Proc
	push	WH_MOUSE
	call	SetWindowsHookEx
	mov		dword ptr[Hook0Handle],eax

ret
InstallHook			endp

RemoveHook			proc
	push	dword ptr[Hook0Handle]
	call	UnhookWindowsHookEx
ret
RemoveHook			endp

_text ends

;; -- Data section ----------------
_data segment dword 'DATA'
	include data/data.asm
	include data/strings.asm
_data ends

_bss  segment dword 'BSS'
	include data/notinit.asm
_bss  ends

end start